include_guard(GLOBAL)

if(CMAKE_SYSTEM_NAME STREQUAL Linux)
  set(MYX_CMAKE_LSB_DISTRIBUTOR_ID "unknown")
  set(MYX_CMAKE_LSB_CODENAME "unknown")
  set(MYX_CMAKE_LSB_RELEASE_VERSION "unknown")

  if(CMAKE_CROSSCOMPILING)
    return()
  endif()

  if(EXISTS /etc/mcst_version)
    set(MYX_CMAKE_LSB_DISTRIBUTOR_ID "ElbrusD")
    set(MYX_CMAKE_LSB_CODENAME "Jessie")
    execute_process(COMMAND cat /etc/mcst_version
      OUTPUT_VARIABLE MYX_CMAKE_LSB_RELEASE_VERSION
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    find_program(LSB_RELEASE_EXECUTABLE lsb_release)
    # cmake-format: off
    if(LSB_RELEASE_EXECUTABLE)
      execute_process(COMMAND ${LSB_RELEASE_EXECUTABLE} -si
        OUTPUT_VARIABLE MYX_CMAKE_LSB_DISTRIBUTOR_ID
        OUTPUT_STRIP_TRAILING_WHITESPACE)
      execute_process(COMMAND ${LSB_RELEASE_EXECUTABLE} -sc
        OUTPUT_VARIABLE MYX_CMAKE_LSB_CODENAME
        OUTPUT_STRIP_TRAILING_WHITESPACE)
      execute_process(COMMAND ${LSB_RELEASE_EXECUTABLE} -sr
        OUTPUT_VARIABLE MYX_CMAKE_LSB_RELEASE_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
    # cmake-format: on
  endif()
endif()
